export = index;
declare class index {
    static createServer(fn: any, options: any): any;
    static createSocket(options: any): any;
    static extend(protoProps: any, staticProps: any): any;
    static get(method: any, getter: any): any;
    static parsers: {
        binary: {
            server: string;
        };
        ejson: {
            server: string;
        };
        json: {};
        msgpack: {
            server: string;
        };
    };
    static readable(method: any, description: any, clean: any): any;
    static set(method: any, getter: any, setter: any): any;
    static transformers: {
        browserchannel: {
            client: string;
            server: string;
        };
        "engine.io": {
            client: string;
            server: string;
        };
        faye: {
            client: string;
            server: string;
        };
        sockjs: {
            client: string;
            server: string;
        };
        uws: {
            client: string;
            server: string;
        };
        websockets: {
            client: string;
            server: string;
        };
    };
    static writable(method: any, description: any, clean: any): any;
    constructor(server: any, options: any);
    auth: any;
    connections: any;
    ark: any;
    layers: any;
    heartbeatInterval: any;
    transformer: any;
    encoder: any;
    decoder: any;
    connected: any;
    whitelist: any;
    options: any;
    transformers: any;
    server: any;
    pathname: any;
    spec: any;
    Spark: any;
    addListener(event: any, fn: any, context: any): any;
    asyncemit(...args: any[]): any;
    authorize(auth: any): any;
    close(options: any, fn: any): any;
    destroy(options: any, fn: any): any;
    disable(name: any): any;
    emit(event: any, a1: any, a2: any, a3: any, a4: any, a5: any, ...args: any[]): any;
    emits(...args: any[]): any;
    enable(name: any): any;
    end(options: any, fn: any): any;
    eventNames(): any;
    forEach(fn: any, done: any): any;
    fuse(a1: any, ...args: any[]): void;
    heartbeat(): any;
    indexOfLayer(name: any): any;
    initialise(Transformer: any, options: any): void;
    is(what: any, where: any): any;
    library(nodejs?: any): any;
    listenerCount(event: any): any;
    listeners(event: any): any;
    merge(target: any, additional: any): any;
    mixin(target: any, ...args: any[]): any;
    off(event: any, fn: any, context: any, once: any): any;
    on(event: any, fn: any, context?: any): any;
    once(event: any, fn: any, context: any): any;
    parsers(parser: any): any;
    plugin(name: any, energon: any): any;
    plugout(name: any): any;
    remove(name: any): any;
    removeAllListeners(event: any): any;
    removeListener(event: any, fn: any, context: any, once: any): any;
    reserved(evt: any): any;
    save(path: any, fn: any): any;
    spark(id: any): any;
    transform(type: any, fn: any): any;
    use(name: any, fn: any, options: any, level: any): any;
    write(data: any): any;
}
declare namespace index {
    class Spark {
        static CLOSED: number;
        static OPEN: number;
        static OPENING: number;
        static extend(protoProps: any, staticProps: any): any;
        static get(method: any, getter: any): any;
        static readable(method: any, description: any, clean: any): any;
        static set(method: any, getter: any, setter: any): any;
        static writable(method: any, description: any, clean: any): any;
        constructor(primus: any, headers: any, address: any, query: any, id: any, request: any, socket: any);
        query: any;
        addListener(type: any, listener: any): any;
        emit(type: any, args: any): any;
        emits(...args: any[]): any;
        end(data: any, options: any): any;
        eventNames(): any;
        fuse(a2: any, ...args: any[]): void;
        getMaxListeners(): any;
        heartbeat(): void;
        listenerCount(type: any): any;
        listeners(type: any): any;
        off(type: any, listener: any): any;
        on(type: any, listener: any): any;
        once(type: any, listener: any): any;
        pipe(dest: any, options: any): any;
        prependListener(type: any, listener: any): any;
        prependOnceListener(type: any, listener: any): any;
        protocol(msg: any): any;
        rawListeners(type: any): any;
        removeAllListeners(type: any, ...args: any[]): any;
        removeListener(type: any, listener: any): any;
        reserved(evt: any): any;
        setMaxListeners(n: any): any;
        transforms(primus: any, connection: any, type: any, data: any, raw: any): any;
        write(data: any): any;
    }
    namespace Spark {
        function predefine(obj: any, pattern: any): any;
        namespace predefine {
            const READABLE: {
                enumerable: boolean;
                writable: boolean;
            };
            const WRITABLE: {
                configurable: boolean;
                enumerable: boolean;
                writable: boolean;
            };
            function create(property: any, description: any, pattern: any): any;
            function descriptor(obj: any): any;
            function each(collection: any, iterator: any, context: any, ...args: any[]): any;
            function extend(protoProps: any, staticProps: any): any;
            function lazy(obj: any, prop: any, fn: any): void;
            function merge(target: any, additional: any): any;
            function mixin(target: any, ...args: any[]): any;
            function remove(obj: any, keep: any): any;
        }
    }
    class Transformer {
        static extend(protoProps: any, staticProps: any): any;
        static get(method: any, getter: any): any;
        static readable(method: any, description: any, clean: any): any;
        static set(method: any, getter: any, setter: any): any;
        static writable(method: any, description: any, clean: any): any;
        constructor(primus: any);
        ultron: any;
        Spark: any;
        primus: any;
        service: any;
        addListener(event: any, fn: any, context: any): any;
        emit(event: any, a1: any, a2: any, a3: any, a4: any, a5: any, ...args: any[]): any;
        emits(...args: any[]): any;
        eventNames(): any;
        forEach(type: any, req: any, res: any, next: any): any;
        fuse(a1: any, ...args: any[]): void;
        initialise(): void;
        listenerCount(event: any): any;
        listeners(event: any): any;
        merge(target: any, additional: any): any;
        mixin(target: any, ...args: any[]): any;
        off(event: any, fn: any, context: any, once: any): any;
        on(event: any, fn: any, context: any): any;
        once(event: any, fn: any, context: any): any;
        removeAllListeners(event: any): any;
        removeListener(event: any, fn: any, context: any, once: any): any;
        request(req: any, res: any): any;
        test(req: any): any;
        upgrade(req: any, socket: any, head: any): any;
    }
    namespace Transformer {
        function predefine(obj: any, pattern: any): any;
        namespace predefine {
            const READABLE: {
                enumerable: boolean;
                writable: boolean;
            };
            const WRITABLE: {
                configurable: boolean;
                enumerable: boolean;
                writable: boolean;
            };
            function create(property: any, description: any, pattern: any): any;
            function descriptor(obj: any): any;
            function each(collection: any, iterator: any, context: any, ...args: any[]): any;
            function extend(protoProps: any, staticProps: any): any;
            function lazy(obj: any, prop: any, fn: any): void;
            function merge(target: any, additional: any): any;
            function mixin(target: any, ...args: any[]): any;
            function remove(obj: any, keep: any): any;
        }
    }
    function predefine(obj: any, pattern: any): any;
    namespace predefine {
        const READABLE: {
            enumerable: boolean;
            writable: boolean;
        };
        const WRITABLE: {
            configurable: boolean;
            enumerable: boolean;
            writable: boolean;
        };
        function create(property: any, description: any, pattern: any): any;
        function descriptor(obj: any): any;
        function each(collection: any, iterator: any, context: any, ...args: any[]): any;
        function extend(protoProps: any, staticProps: any): any;
        function lazy(obj: any, prop: any, fn: any): void;
        function merge(target: any, additional: any): any;
        function mixin(target: any, ...args: any[]): any;
        function remove(obj: any, keep: any): any;
    }
}
